mod tokenizer;
use tokenizer::*;

mod parser;
use parser::*;

mod executor;
use executor::*;

fn main() {
    let source = std::fs::read_to_string("src/test.lisp").unwrap();
    let mut tokenizer = Tokenizer::new(source);
	let tokens = match tokenizer.tokenize() {
		Ok(tokens) => tokens,
		Err(e) => {
			println!("{}", e);
			Vec::new()
		}
	};
	let instructions = parse(tokens);

	let state = LispState::new();

	state.execute(instructions);
}
